=== debian/changelog ===
lz4 (1.9.1-1) experimental; urgency=medium

  * New upstream release.
  * Update d/patches.
  * Update debian/liblz4-1.symbols.
    Add APIs following:
      - LZ4F_getBlockSize@Base 
      - LZ4_compress_HC_continue_destSize@Base 
      - LZ4_compress_HC_destSize@Base 
      - LZ4_initStream@Base 
      - LZ4_initStreamHC@Base 
      - LZ4_resetStreamHC_fast@Base 
    Remove APIs following:
      - LZ4_attach_HC_dictionary@Base
      - LZ4_attach_dictionary@Base
      - LZ4_compress_fast_extState_fastReset@Base

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 24 May 2019 07:51:04 +0900
