=== debian/changelog ===
lz4 (1.9.2-2ubuntu0.20.04.1) focal-security; urgency=medium

  * SECURITY UPDATE: memory corruption due to an integer overflow bug
    - debian/patches/CVE-2021-3520.patch: check outputSize in lib/lz4.c.
    - CVE-2021-3520

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 May 2021 12:38:57 -0400

lz4 (1.9.2-2) unstable; urgency=medium

  * Fix FTCBFS: Annotate the python3 dependency. (Closes: #944559)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 12 Nov 2019 07:58:47 +0900

lz4 (1.9.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #943680)
    Fix CVE-2019-17543.
  * Add d/patches/change-optimize.patch.
    Change optimize and add debugging information.
  * Update d/control.
    Add python3 to B-D.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 29 Oct 2019 19:19:36 +0900

lz4 (1.9.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 20 Aug 2019 22:43:48 +0900
