=== debian/changelog ===
lz4 (1.9.3-2) unstable; urgency=medium

  * Fix CVE-2021-3520. (Closes: #987856)
    - This fixed potential memory corruption with negative memmove() size.
    - Add d/patches/0005-CVE-2021-3520.patch

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 05 May 2021 16:29:57 +0900

lz4 (1.9.3-1) unstable; urgency=medium

  * New upstream release.
  * Update d/control.
    - Use debhelper-compat, and update to 13.
    - Bump Standards-Version to 4.5.0 (no changes)
  * Add d/upstream/metadata.
  * Update d/liblz4-1.symbols.
    Add LZ4F_headerSize@Base 1.9.3.
  * Update d/patches.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 01 Dec 2020 06:07:12 +0900
