=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: lz4
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
-Build-Depends: debhelper (>= 9.0.0), python3:any <!nocheck>
-Standards-Version: 4.1.0
+Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
+Build-Depends: debhelper-compat (= 13), python3:any <!nocheck>
+Standards-Version: 4.5.1
 Section: utils
 Homepage: https://github.com/Cyan4973/lz4
 Vcs-Browser: https://salsa.debian.org/debian/lz4
