=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- CC=$(CC)
+	dh_auto_build -- CC=$(CC) V=1
 
 override_dh_auto_install:
 	dh_auto_install -- \
